window.addEventListener("load", function(){
var theButton;
var ToolbarUIItemProperties = {
  title: "InSite Search",
  icon: "icon.png",
  popup: {
    href: "searchbar.html",
    width: 345,
    height: 220
  }
}

theButton = opera.contexts.toolbar.createItem(ToolbarUIItemProperties);
opera.contexts.toolbar.addItem(theButton);

opera.extension.onmessage = function(event){
  // send search query
  if (event.data.action == 'search') {  
    if (event.data.query) {
      var tab = opera.extension.tabs.getFocused();
      if (tab) {
        var host = tab.url
        var pos = host.indexOf("//");
        if (pos != -1) {
          host = host.substring(pos+2);
          pos = host.indexOf("/")
          if (pos != -1) {
              host = host.substr(0, pos);
          }
        }
        var url = '';
        var engine = 'google';
        if (widget.preferences.engine) {
          engine = widget.preferences.engine;
        }
        if (engine == 'bing') {
          url = 'http://www.bing.com/search?q=' + event.data.query + ' site:' + host;
        } else if (engine == 'yandex') {
          url = 'http://yandex.ru/yandsearch?surl=' + host + '&text=' + event.data.query;
        } else if (engine == 'baidu') {
          url = 'http://www.baidu.com/s?wd=' + event.data.query + ' site:' + host;
        } else if (engine == 'yahoo') {
          url = 'http://search.yahoo.com/search?p=' + event.data.query + ' site:' + host;
        } else {
          url = 'http://google.com/search?q=' + event.data.query + ' site:' + host;
        }
        // open in the current tab
        if (widget.preferences.current && widget.preferences.current == 'yes') {
          tab.update({ url: url });
        } else {
		  // create new tab
          if(opera.extension.tabs.create) {
            opera.extension.tabs.create({
              url: url,
              focused: true
            });
	  	  }
        }
	  }
    }
  } else if (event.data.action == 'open') {  
	theButton.popup.height = 165;
  } else if (event.data.action == 'close') { 
	theButton.popup.height = 40;   
  }
}

}, false);

